Prime Path 分类: 搜索 POJ 2015-08-09 16:21 4人阅读 评论(0) 收藏

Prime Path
Time Limit: 1000MS Memory Limit: 65536K
Total Submissions: 14091 Accepted: 7959

Description
The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices.
— It is a matter of security to change such things every now and then, to keep the enemy in the dark.
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know!
— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door.
— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime!
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds.
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime.

Now, the minister of finance, who had been eavesdropping, intervened.
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound.
— Hmm, in that case I need a computer program to minimize the cost. You don’t know some very cheap software gurus, do you?
— In fact, I do. You see, there is this programming contest going on… Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above.

1033
1733
3733
3739
3779
8779
8179

The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.

Input
One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).

Output
One line for each case, either with a number stating the minimal cost or containing the word Impossible.

Sample Input

3
1033 8179
1373 8017
1033 1033

Sample Output

6
7
0

Source
Northwestern Europe 2006
没什么好说的,BFS搜索,就是在搜索的时候,千位不能为零QAQ

#include <map>
#include <list>
#include <climits>
#include <cmath>
#include <queue>
#include <stack>
#include <string>
#include <cstdio>
#include <cstring>
#include <cstdlib>
#include <iostream>
#include <algorithm>
using namespace std;
#define eps 1e-9
#define LL unsigned long long
#define PI acos(-1.0)
#define INF 0x3f3f3f3f
#define CRR fclose(stdin)
#define CWW fclose(stdout)
#define RR freopen("input.txt","r",stdin)
#define WW freopen("output.txt","w",stdout)

const int Max = 10010;
struct node
{
    int x;
    int num;
};

int n,m;
bool prime[Max];
bool vis[Max];
int bfs()
{
    memset(vis,false,sizeof(vis));
    node a,b;
    a.num=0;
    a.x=n;
    queue<node>Q;
    vis[n]=true;
    Q.push(a);
    while(!Q.empty())
    {
        a=Q.front();
        Q.pop();
        if(a.x==m)
        {
            return a.num;
        }
        for(int i=0;i<10;i++)
        {
            b.x=a.x/10*10+i;
            b.num=a.num+1;
            if(!vis[b.x]&&!prime[b.x])
            {
                vis[b.x]=true;
                Q.push(b);
            }
        }
        for(int i=0;i<10;i++)
        {
            int s=a.x%10;
            b.x=a.x/100*100+i*10+s;
            b.num=a.num+1;
            if(!vis[b.x]&&!prime[b.x])
            {
                vis[b.x]=true;
                Q.push(b);
            }
        }
        for(int i=0;i<10;i++)
        {
            int s=a.x%100;
            b.x=a.x/1000*1000+i*100+s;
            b.num=a.num+1;
            if(!vis[b.x]&&!prime[b.x])
            {
                vis[b.x]=true;
                Q.push(b);
            }
        }
        for(int i=1;i<10;i++)
        {
            b.x=a.x%1000+i*1000;
            b.num=a.num+1;
            if(!vis[b.x]&&!prime[b.x])
            {
                vis[b.x]=true;
                Q.push(b);
            }
        }
    }
    return 0;
}
int main()
{
    memset(prime,false,sizeof(prime));
    prime[1]=true;
    prime[0]=true;
    m=sqrt(Max)+1;
    for(int i=2;i<m;i++)
    {
        if(!prime[i])
        {
            for(int j=i*i;j<=Max;j+=i)
            {
                prime[j]=true;
            }
        }
    }
    int T;
    scanf("%d",&T);
    while(T--)
    {
        scanf("%d %d",&n,&m);
        printf("%d\n",bfs());
    }
    return 0;
}

版权声明:本文为博主原创文章,未经博主允许不得转载。

posted @ 2015-08-09 16:21  一骑绝尘去  阅读(100)  评论(0编辑  收藏  举报